/**********************************************************/
/*                    IBM Confidential                    */
/*      (IBM Confidential-Restricted when combined        */
/*       with the Aggregated OCO Source Modules for       */
/*       this Program)                                    */
/*                                                        */
/*                 OCO Source Materials                   */
/*                                                        */
/*        IBM AIX Speech Server/6000    Release 1.0       */
/*          5777-WCQ (C) Copyright IBM Corp. 1992         */
/**********************************************************/
/*=====================================================================*/
/*                                                                     */
/*  smacomm.h                                                          */
/*                                                                     */
/*                                                                     */
/*  Smacomm - Implements a general dispatching mechanism               */
/*                                                                     */
/*=====================================================================*/

/* $Header: /tanglite/cvsroot/vv/api/smacomm.h,v 2.3 1999/04/05 22:17:21 burn Exp $
 *
 * $Log: smacomm.h,v $
 * Revision 2.3  1999/04/05 22:17:21  burn
 * Linux changes: external notifier; drop msg queue support
 *
 * Revision 2.2  1995/08/18 21:50:12  degenn
 * Added ifdef __cplusplus.
 *
 * Revision 2.1  94/03/22  12:12:08  kushi
 * AIX message queues and notification groups
 * 
 * Revision 2.0  94/01/04  15:01:20  burn
 * Changed revision number only
 * 
 * Revision 1.3  93/02/05  17:53:04  kushi
 * dk converged speech manager api changes
 * 
 *
 * Revision 1.3  92/12/04  10:50:56  kunzmann
 * added support for time out functions in ASCII mode, mapped smapi
 * calls to smsapi.c call to save string tables.
 *
 * Revision 1.2  92/11/10  14:03:48  kunzmann
 * fixed a bug in dispatching msg queues, added support to poll a SmInputId
 * from the client side, added checkeing for maximum number of message queues
 *
 * Revision 1.1  92/11/08  17:22:21  kunzmann
 * Initial revision
 *
 *
*/

#ifndef SM_ACOMM_H_INCLUDED
#define SM_ACOMM_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------------------------------------*/
/* input id returned from SmAddInput                                      */
/*------------------------------------------------------------------------*/
typedef void *SmInputId;

/*------------------------------------------------------------------------*/
/* allowed input conditions                                               */
/*------------------------------------------------------------------------*/
#define SmInputReadMask       (1<<0)
#define SmInputWriteMask      (1<<1)
#define SmInputExceptMask     (1<<2)

/*------------------------------------------------------------------------*/
/* protopye of the callback function                                      */
/*------------------------------------------------------------------------*/
typedef int (*SmInputHandler)(
#if NeedFunctionPrototypes
    caddr_t,                                               /* client_data */
    int        *,                                    /* pointer to source */
    XtInputId  *                                   /* pointer to input id */
#endif
);

/*------------------------------------------------------------------------*/
/* function prototypes for the removing of input/output handler for file  */
/* descriptors                                                            */
/*------------------------------------------------------------------------*/
extern SmInputId SmAddInput    ( int            source,
                                 int            condition,
                                 SmInputHandler handler,
                                 caddr_t        client_data );

extern int       SmRemoveInput ( SmInputId input_id );

/*------------------------------------------------------------------------*/
/* function prototype for the querying if data is available on a          */
/* valid SmInputId                                                        */
/*------------------------------------------------------------------------*/
extern int       SmQueryInput          ( SmInputId input_id );

/*------------------------------------------------------------------------*/
/* main loop function                                                     */
/*------------------------------------------------------------------------*/
extern int       SmMainLoop ( );

#ifdef __cplusplus
}
#endif

#endif  /* SM_ACOMM_H_INCLUDED */
