//------------------------------------------------------------------------------
//
// COPYRIGHT:
// ----------
// Copyright (C) International Business Machines Corp., 1996.
//
// DISCLAIMER OF WARRANTIES:
// -------------------------
// The following [enclosed] code is sample code created by IBM
// Corporation.  This sample code is not part of any standard IBM
// product and is provided to you solely for the purpose of
// assisting you in the development of your applications.  The
// code is provided "AS IS", without warranty of any kind.  IBM
// shall not be liable for any damages arising out of your use of
// the sample code, even if they have been advised of the
// possibility of such damages.
//
//------------------------------------------------------------------------------
// chkDlg.cpp : implementation file
//
// extended to use the language code to load the right files
// moved all of the file name templates into #defines
//
#define CCD_FSTEM_CHKCMD   "\\chkcmd"     // command list
#define CCD_FSTEM_DATES    "\\dates1"     // dates recognized
#define CCD_FSTEM_PAYEE    "\\payee"      // who can we pay to?
#define CCD_FSTEM_CURNCY   "\\curncy"     // what is our currency?
#define CCD_FSTEM_TIPS_TEXT    "\\tips"   // tips text file
#define CCD_FEXTS_TEXT     ".TXT"         // tips text file extension
#define CCD_FEXTS_GRAMMAR  ".FSG"         // grammar files extension

#include "stdafx.h"
#include "chk.h"
#include "chkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define  VT_APP_NAME         "check"   // app+ViaVoice specific stuff
#define  VT_CONNECT_ID       657       // app+ViaVoice specific stuff

#define  VT_APP_NAV_VOCAB    "chkcmds" // vocab name for navigating app


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChkDlg dialog

CChkDlg::CChkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChkDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// clean out the apchTips //
	for ( int iInx = (int) TipOnDate; iInx < (int)NumOfTips; iInx++ )
		/* clean the substrings */
	    memset( apchTips[iInx], 0, sizeof( apchTips[iInx]) );
}

void CChkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChkDlg)
	DDX_Control(pDX, IDC_MIKE, m_mike);
	DDX_Control(pDX, IDC_USER_PROMPT, m_user_prompt);
	DDX_Control(pDX, IDC_PAYTO, m_payto);
	DDX_Control(pDX, IDC_NOTES, m_notes);
	DDX_Control(pDX, IDC_FOR, m_for);
	DDX_Control(pDX, IDC_DATE, m_date);
	DDX_Control(pDX, IDC_AMOUNT_TEXT, m_amount_text);
	DDX_Control(pDX, IDC_AMOUNT, m_amount);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChkDlg, CDialog)
	//{{AFX_MSG_MAP(CChkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_SETFOCUS(IDC_FOR, OnSetfocusFor)
	ON_EN_KILLFOCUS(IDC_FOR, OnKillfocusFor)
	ON_EN_SETFOCUS(IDC_DATE, OnSetfocusDate)
	ON_EN_KILLFOCUS(IDC_DATE, OnKillfocusDate)
	ON_EN_SETFOCUS(IDC_PAYTO, OnSetfocusPayto)
	ON_EN_KILLFOCUS(IDC_PAYTO, OnKillfocusPayto)
	ON_EN_SETFOCUS(IDC_NOTES, OnSetfocusNotes)
	ON_EN_KILLFOCUS(IDC_NOTES, OnKillfocusNotes)
	ON_EN_SETFOCUS(IDC_AMOUNT_TEXT, OnSetfocusAmountText)
	ON_EN_KILLFOCUS(IDC_AMOUNT_TEXT, OnKillfocusAmountText)
	ON_BN_CLICKED(IDC_MIKE, OnMike)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChkDlg message handlers

BOOL CChkDlg::OnInitDialog()
{
   int rc;
   const char *task;

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// ViaVoice initialization
   m_pCurrentDictCtrl = NULL;
   m_pCurrentGramCtrl = NULL;

   rc = voicetype.connect( VT_APP_NAME, m_hWnd, VT_CONNECT_ID, FALSE );

   task = voicetype.getDefaultTask();

   if ( !strncmp( task, "nav", 3 ) )
   {
      MessageBox( "Error: Wrong default task\n\n"
         "This sample program requires a dictation vocabulary\n\n"
         "Install dictation and/or select the General Dictation Vocabulary\n"
         "in the Control Panel, VoiceCenter Properties" );
      exit( 0 );
   }

   if ( voicetype.isMessageWaiting() )
      promptLine( voicetype.getMessage() );

   // perform language specific inits
   if ( loadByLanguage() )
   {                           // something went badly wrong
     promptLine( "Error: Cannot load language specific data.\r\n" );
   }

   // fetch first replies
   if ( voicetype.isMessageWaiting() )
      promptLine( voicetype.getMessage() );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//-----------------------------------------------------------------------------
//  promptLine()
//-----------------------------------------------------------------------------
//
//  This method prints a line to the m_user_prompt control
//

void CChkDlg::promptLine( const char * line )
{
   m_user_prompt.ReplaceSel( line );
   m_user_prompt.ReplaceSel( "\r\n" );
}


//-----------------------------------------------------------------------------
//  doCommand()
//-----------------------------------------------------------------------------
//
//  This method is a very simple illustration of annotations in action.  A
//  grammar is defined for navigating the app, the commands are simple and
//  numbered 1 through 10.  The annotation gets pulled out by the Proxy and
//  the number representing the command is passed in.
//
//             The grammar (chkcmds.bnf) looks like this:
//
// <chkappcmd> =   exit:0
//               | previous field:1
//               | next field:2
//               | date:3
//               | pay to:4
//               | amount:5
//               | dollars:6
//               | for:7
//               | memo:8
//               | notes:9
//               | microphone off:10
//               .
//

void CChkDlg::doCommand( long command )
{
   char message[80];

   sprintf( message, "Processing numeric grammar annotation: %d", command );
   promptLine( message );

   switch ( command )
   {
      case 0:                          // exit
         EndDialog( 0 );
         break;

      case 1:                          // previous field
         PrevDlgCtrl();
         break;

      case 2:                          // next field
         NextDlgCtrl();
         break;

      case 3:                          // date
         GotoDlgCtrl( &m_date );
         break;

      case 4:                          // pay to
         GotoDlgCtrl( &m_payto );
         break;

      case 5:                          // amount
      case 6:                          // dollars
         GotoDlgCtrl( &m_amount_text );
         break;

      case 7:                          // for
      case 8:                          // memo
         GotoDlgCtrl( &m_for );
         break;

      case 9:                          // notes
         GotoDlgCtrl( &m_notes );
         break;

      case 10:                         // microphone off
         m_mike.SetWindowText( "Microphone On" );
         voicetype.stopRecognizing();
         break;

      default:                         // this should never happen!
         MessageBox( "Unexpected Annotation" );
         break;
   }
}


//-----------------------------------------------------------------------------
//   doDollarAnnotations()
//-----------------------------------------------------------------------------
//
//  Converts annotations like: "4 *1000 2 *100 17 $ 90 6" to "4217.96"
//
//  This method takes a string which is a series of concatenated string 
//  annotations from the _dollars.bnf (.fsg) grammar.  The VTProxy class has
//  taken individual annotations and concatenated them into the string which
//  is passed in here as 'formula'.  The formula string has dollars and cents
//  information stored in a format which can be converted to numbers for
//  addition and multiplication, then converted back to a string for display
//  in the numeric amount field of the check.  The text phrase for the example
//  above "FOUR THOUSAND TWO HUNDRED SEVENTEEN DOLLARS AND NINETY SIX CENTS"
//  is simply printed to the text amount field and is not relevant to the
//  process of creating the numeric representation done here.
//

#define PARSE_DOLLARS   1
#define PARSE_CENTS     2
#define PARSE_DONE      3

void CChkDlg::doDollarAnnotations( const char * formula )
{
   int state;                          // tracks progress: dollars->cents->done
   unsigned int start;                 // index at start of current substring
   unsigned int end;                   // index at end of current substring
   unsigned int len;                   // length of formula string
   char temp[256];                     // holds a substring
   char temp2[256];                    // holds another substring (multiplier)
   int amount = 0;                     // accumulates dollar amount
   int cents = 0;                      // accumulates cents
   int num1;                           // utility variable
   int num2;                           // utility variable
   

   sprintf( temp, "Parsing annotation: \"%s\"", formula );
   promptLine( temp );

   state = PARSE_DOLLARS;
   len = strlen( formula );
   start = end = 0;
   while ( formula[ end ] != ' ' ) ++end;    // find the end of the substring

   temp[0] = '\0';
   temp2[0] = '\0';

   while ( state == PARSE_DOLLARS )
   {
      strncpy( temp, &formula[ start ], (end - start) );   // copy substring
      temp[ end - start ] = '\0';                          // and terminate it
      num1 = atoi( temp );                      // convert substring to integer

      start = end+1;                            // look at next substring
      end = end+1;                              // look at next substring
      while ( formula[ end ] != ' ' ) ++end;    // find the end of substring

      if ( formula[ start ] == '*' )            // if next token is multiplier
      {
         strncpy( temp2, &formula[ start + 1 ], (end - start - 1) );
         temp2[ end - start - 1 ] = '\0';
         num2 = atoi( temp2 );
      
         amount += num1 * num2;

         start = end+1;                            // look at next substring
         end = end+1;                              // look at next substring
         while ( formula[ end ] != ' ' ) ++end;    // find the end of substring
      }
      else                                         // next is not a multiplier
      {
         amount += num1;                           // just add current number

         if ( start >= len )
            state = PARSE_DONE;
      }

      if ( formula[ start ] == '$' )               // next is end of dollars
         state = PARSE_CENTS;
   }

   if ( state == PARSE_CENTS && (len > start + 2) )
   {
      start = end+1;                               // look at next substring
      end = end+1;                                 // look at next substring
      while ( formula[ end ] != ' ' ) ++end;       // find the end of substring

      strncpy( temp, &formula[ start ], (end - start) );   // copy substring
      temp[ end - start ] = '\0';                          // and terminate it
      cents = atoi( temp );                        // convert substring to int

      if ( start <= len )                          // more cents?
      {
         start = end+1;                            // look at next substring
         end = end+1;                              // look at next substring
         while ( formula[ end ] != ' ' ) ++end;    // find the end of substring

         strncpy( temp, &formula[ start ], (end - start) );   // copy substring
         temp[ end - start ] = '\0';                          // and terminate
         cents += atoi( temp );                    // convert substring to int
      }
   }
   
   sprintf( temp, "%d.%02d", amount, cents );
   m_amount.SetSel( 0, -1, TRUE );
   m_amount.ReplaceSel( temp );
}


//-----------------------------------------------------------------------------
//  OnCommand()
//-----------------------------------------------------------------------------
//
//  This method receives messages from the engine and passes them to the proxy
//

BOOL CChkDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
//	int hold, selFirst, selLast;
//   static int y = 0;
   BOOL status;
//   VTWord * pWord;

   status = FALSE;

   switch( wParam )
   {
      case ID_HELP:
         MessageBox( "No Help available for this sample program" );
         break;

      case VT_CONNECT_ID:
         voicetype.engineMessage( lParam );

         displayDictatedWords();

         if ( voicetype.isPhraseWaiting() )
         {
            const char * phrase = voicetype.getPhrase();
            const char * vocab = voicetype.getPhraseVocab();

            if ( !strcmp( vocab, VT_APP_NAV_VOCAB ) )
            {
               if ( voicetype.isAnnotationWaiting() 
                    && strncmp( phrase, "??", 2 ) )
               {
                  doCommand( voicetype.getNumAnnotation() );
               }
            }
            else
            {
               if ( m_pCurrentGramCtrl )
               {
                  m_pCurrentGramCtrl->ReplaceSel( phrase );
                  m_pCurrentGramCtrl->SetSel( 0, -1, TRUE );
               }

               if ( !strcmp( vocab, "stopcmd" ) )
               {
                  voicetype.enableVocabulary( VT_APP_NAV_VOCAB ); // turn it back on;
                  voicetype.startRecognizing();
               }

               if ( !strcmp( vocab, "_dollars" ) )
               {
                  if ( strncmp( phrase, "??", 2 ) )
                     doDollarAnnotations( voicetype.getStrAnnotation() );
                  else
                  {
                     m_amount.SetSel( 0, -1, TRUE );
                     m_amount.ReplaceSel( "VOID" );
                  }
               }
            }
         }

         if ( voicetype.isMessageWaiting() )
            promptLine( voicetype.getMessage() );

         break;

      default:
         status = CDialog::OnCommand(wParam, lParam);
   }

	return( status );
}


//-----------------------------------------------------------------------------
//  OnSetfocusDate()
//-----------------------------------------------------------------------------
//
//  called when date control gets focus
//

void CChkDlg::OnSetfocusDate() 
{
   m_pCurrentGramCtrl = &m_date;
   m_date.SetSel( 0, -1, TRUE );

   giveTip( TipOnDate);

   voicetype.enableVocabulary( "dates" );
   voicetype.startRecognizing();
}


//-----------------------------------------------------------------------------
//  OnKillfocusDate()
//-----------------------------------------------------------------------------
//
//  Called when date control loses focus
//

void CChkDlg::OnKillfocusDate() 
{
   voicetype.stopRecognizing();
   voicetype.disableGrammar( "dates" );

   m_pCurrentGramCtrl = NULL;
}


//-----------------------------------------------------------------------------
//  OnSetfocusPayto()
//-----------------------------------------------------------------------------
//
//  Called when payto control gets focus
//

void CChkDlg::OnSetfocusPayto() 
{
   m_pCurrentGramCtrl = &m_payto;
   m_payto.SetSel( 0, -1, TRUE );

   giveTip( TipOnPayTo);

   voicetype.enableVocabulary( "payee" );
   voicetype.startRecognizing();
}


//-----------------------------------------------------------------------------
//  OnKillfocusPayto()
//-----------------------------------------------------------------------------
//
//  Called when payto control loses focus
//

void CChkDlg::OnKillfocusPayto() 
{
   voicetype.stopRecognizing();
   voicetype.disableGrammar( "payee" );

   m_pCurrentGramCtrl = NULL;
}


//-----------------------------------------------------------------------------
//  OnSetfocusAmountText()
//-----------------------------------------------------------------------------
//
//  Called when amount_text control gets focus
//

void CChkDlg::OnSetfocusAmountText() 
{
   m_pCurrentGramCtrl = &m_amount_text; 
   m_amount_text.SetSel( 0, -1, TRUE );

   giveTip( TipOnAmount);
	
   voicetype.enableVocabulary( "_dollars" );	
   voicetype.startRecognizing();
}


//-----------------------------------------------------------------------------
//  OnKillfocusAmountText()
//-----------------------------------------------------------------------------
//
//  Called when amount_text control loses focus
//

void CChkDlg::OnKillfocusAmountText()
{
   voicetype.stopRecognizing();
   voicetype.disableGrammar( "_dollars" );

   m_pCurrentGramCtrl = NULL;
}


//-----------------------------------------------------------------------------
//  OnSetfocusFor()
//-----------------------------------------------------------------------------
//
//  Called when for control (DICTATION) gets focus.
//

void CChkDlg::OnSetfocusFor() 
{
   m_pCurrentDictCtrl = &m_for;
   m_for.SetSel( 0, -1, TRUE );

   giveTip( TipOnFor);
  
   voicetype.disableGrammar( VT_APP_NAV_VOCAB );   // dictation would kill it
   
   voicetype.stopRecognizing();

   voicetype.beginDictation( TRUE );
}


//-----------------------------------------------------------------------------
//  OnKillfocusFor()
//-----------------------------------------------------------------------------
//
//  Called when for control (DICTATION) loses focus.
//

void CChkDlg::OnKillfocusFor() 
{
   voicetype.stopDictation();
   displayDictatedWords();

   voicetype.enableVocabulary( VT_APP_NAV_VOCAB ); // turn it back on;
   voicetype.startRecognizing();
  	
   m_pCurrentDictCtrl = NULL;
}


//-----------------------------------------------------------------------------
//  OnSetfocusNotes()
//-----------------------------------------------------------------------------
//
//  Called when notes control (DICTATION) gets focus
//

void CChkDlg::OnSetfocusNotes() 
{
   m_pCurrentDictCtrl = &m_notes;
   m_notes.SetSel( 0, -1, TRUE );
  
   giveTip( TipOnNotes);
  
   voicetype.disableGrammar( VT_APP_NAV_VOCAB );   // dictation would kill it

   voicetype.stopRecognizing();

   voicetype.beginDictation( TRUE );
}


//-----------------------------------------------------------------------------
//  OnKillfocusNotes()
//-----------------------------------------------------------------------------
//
//  Called when notes control (DICTATION) loses focus
//

void CChkDlg::OnKillfocusNotes() 
{
   voicetype.stopDictation();
   displayDictatedWords();

   voicetype.enableVocabulary( VT_APP_NAV_VOCAB ); // turn it back on;
   voicetype.startRecognizing();
  	
   m_pCurrentDictCtrl = NULL;
}


//-----------------------------------------------------------------------------
//  OnMike()
//-----------------------------------------------------------------------------
//
//  Called when microphone button is pressed.
//

void CChkDlg::OnMike() 
{
   if ( voicetype.isRecognizing() )
   {
      voicetype.stopRecognizing();
      m_mike.SetWindowText( "Microphone On" );
   }	
   else
   {
      voicetype.startRecognizing();
      m_mike.SetWindowText( "Microphone Off" );
   }
}


//-----------------------------------------------------------------------------
//  displayDictatedWords()
//-----------------------------------------------------------------------------
//
//  Displays dictated words into the current dictation control
//

void CChkDlg::displayDictatedWords( void ) 
{
	int hold, selFirst, selLast;
   VTWord * pWord;

   if( voicetype.isWordWaiting() )
   {
      pWord = voicetype.getLastDisplayedWord(); // start at 1st new word

      if ( pWord == NULL )       // no new words, must be first batch
         pWord = voicetype.getFirstWordNU();

      else                       // added to end of list
         pWord = voicetype.getNextWordNU( pWord );

      while ( pWord )            // more words to be displayed
      {
         // display a word and a space
         if ( m_pCurrentDictCtrl )
         {
            m_pCurrentDictCtrl->ReplaceSel( pWord->spelling );   
            m_pCurrentDictCtrl->ReplaceSel( " " );
         }
               
         // point to next word in wordlist
         pWord = voicetype.getNextWordNU( pWord );
      }

      if ( m_pCurrentDictCtrl )   // active control is a dictation field
      {
         m_pCurrentDictCtrl->GetSel( selFirst, selLast );  // caret at end of text
         hold = selFirst;

         m_pCurrentDictCtrl->ReplaceSel( voicetype.getInfirmBuff() );
         m_pCurrentDictCtrl->GetSel( selFirst, selLast );
         m_pCurrentDictCtrl->SetSel( hold, selLast );

         voicetype.allWordsProcessed();
      }
   }
}

//-----------------------------------------------------------------------------
//  loadByLanguage
//-----------------------------------------------------------------------------
//
//  loads the assorted grammars and tips files by the current language code
//

int	CChkDlg::loadByLanguage()
{
	
   DWORD bufflen = 256;
   char currentDir[ 256 ];
   char fsgName[ 256 ];
   const char* cpchLangCode;		// currently active language code


   promptLine( "Loading data and .FSG's from current directory..." );

   // figure out where we are 
   GetCurrentDirectory( bufflen, (LPTSTR) currentDir );
   cpchLangCode = voicetype.getLanguageCodeTail();

   // build tip filename, load it 
   makeLangSpecificFile( fsgName, currentDir, CCD_FSTEM_TIPS_TEXT, cpchLangCode, CCD_FEXTS_TEXT);
   if ( loadTipFile( fsgName) )
   { 
      promptLine( "Error: cannot load file with tips:" );
      promptLine( fsgName );
      return -1;
   } 

   // load the grammar files
   makeLangSpecificFile( fsgName, currentDir, CCD_FSTEM_DATES, cpchLangCode, CCD_FEXTS_GRAMMAR);
   voicetype.defineGrammar( fsgName, "dates" );
   if ( voicetype.isMessageWaiting() )
      promptLine( voicetype.getMessage() );

   makeLangSpecificFile( fsgName, currentDir, CCD_FSTEM_PAYEE, cpchLangCode, CCD_FEXTS_GRAMMAR);
   voicetype.defineGrammar( fsgName, "payee" );
   if ( voicetype.isMessageWaiting() )
      promptLine( voicetype.getMessage() );

   makeLangSpecificFile( fsgName, currentDir, CCD_FSTEM_CURNCY, cpchLangCode, CCD_FEXTS_GRAMMAR);
   voicetype.defineGrammar( fsgName, "_dollars" );
   if ( voicetype.isMessageWaiting() )
      promptLine( voicetype.getMessage() );

   makeLangSpecificFile( fsgName, currentDir, CCD_FSTEM_CHKCMD, cpchLangCode, CCD_FEXTS_GRAMMAR);
   voicetype.defineGrammar( fsgName, VT_APP_NAV_VOCAB );
   if ( voicetype.isMessageWaiting() )
      promptLine( voicetype.getMessage() );
   voicetype.enableVocabulary( VT_APP_NAV_VOCAB );
   if ( voicetype.isMessageWaiting() )
      promptLine( voicetype.getMessage() );

   return 0;
}

//-----------------------------------------------------------------------------
//  makeLangSpecificFile
//-----------------------------------------------------------------------------
//
//  returns the language specific file built from the components passed in
//

char*	CChkDlg::makeLangSpecificFile( char * pchFile,		 // result
                                       const char * pchDir,  // path
                                       const char * pchTempl,// template 
                                       const char * pchLang, // language
                                       const char * pchExt)	 // file extension
{
	strcpy( pchFile, pchDir);							//path first
	if ( *pchTempl != '\\' )
	   /* guard against missing directory slashes */
	   strcat( pchFile, "\\");	
	strcat( pchFile, pchTempl);							// followed by template
	strcat( pchFile, pchLang);							// and the language code
	strcat( pchFile, pchExt);							// plus the extension

	return pchFile;
}



//-----------------------------------------------------------------------------
//  giveTip
//-----------------------------------------------------------------------------
//
//  gives the tip appropriate for the situation. 

void	CChkDlg::giveTip( Tips tip )
{

	if ( tip < TipOnDate || tip >= NumOfTips )
	   /* bad value here */
	   promptLine( "Implementation error: invalid tip requested.\r\n" ); 
	else
	   /* good value found */
	   promptLine( apchTips[ tip] );
		 
}

//-----------------------------------------------------------------------------
//  loadTipFile
//-----------------------------------------------------------------------------
//
//  opens the passed in file and interprets the first five lines as being tips
//

int		CChkDlg::loadTipFile( char * pchFileName)
{

	FILE *fl;				// input file handle

    // attempt an open //
	if ( (fl = fopen( pchFileName, "r")) == NULL )
	   { /* cannot read input file */
		 loadDefaultTips();
		 return -1;
	   } /* end-if: cannot read input file */

	// read the first couple of lines //
	for ( int iInx = (int)TipOnDate; iInx < (int)NumOfTips; iInx++ )
	    { /* process another line */
		  fgets( apchTips[iInx], sizeof( apchTips[iInx]), fl);
		  if ( feof( fl) )
		     { /* less lines than needed */
			  promptLine( "I/O error: not enough tips. ");
			  fclose( fl);
			  loadDefaultTips();
			  return -1;
			 } /* end-if: less lines than needed */
		  else
		  if ( ferror( fl) )
		     { /* some I/O error */
			   promptLine( "I/O error reading entry ");
			   itoa( iInx, apchTips[iInx], 10);
			   promptLine( apchTips[iInx]);
			   promptLine( ".\r\n");
			   fclose( fl);
			   loadDefaultTips();
			   return -1;
			 } /* end-else-if: some I/O error */
		  else
		     { /* yes, all is well */
			   int iLength = strlen( apchTips[iInx] );	
			   apchTips[iInx][iLength-1] = '\0';		// toss final CR
	         } /* end-else: yes, all is well */
		} /* end-for: process another line */

	// yes, all went well //

	return 0;
}

//-----------------------------------------------------------------------------
//  loadDefaultTips
//-----------------------------------------------------------------------------
//
//  called when all else fails; fills in the default tips (ie. US)
//

void	CChkDlg::loadDefaultTips()
{

	static char* apchDefTips[ NumOfTips ] =
	{ /* defaults used when load error */
      "TIP: say date like: \"March-twenty-three\"",
      "TIP: say \"International Business Machines\" or \"Hawaii Pacific College\"",
      "TIP: say dollar amount like: \"Four Hundred\"",
      "TIP: Dictate what the check is for",
      "TIP: Dictate notes about the check"
	}; /* end-static: apchDefTips */

	for ( int iInx = (int)TipOnDate; iInx < (int)NumOfTips; iInx++ )
		/* get the defaults in */
		strcpy( apchTips[ iInx], apchDefTips[ iInx] );
}
