//------------------------------------------------------------------------------
//
//    COPYRIGHT:
//    ----------
//    Copyright (C) International Business Machines Corp., 1996.
//
//      DISCLAIMER OF WARRANTIES:
//      -------------------------
//      The following [enclosed] code is sample code created by IBM
//      Corporation.  This sample code is not part of any standard IBM
//      product and is provided to you solely for the purpose of
//      assisting you in the development of your applications.  The
//      code is provided "AS IS", without warranty of any kind.  IBM
//      shall not be liable for any damages arising out of your use of
//      the sample code, even if they have been advised of the
//      possibility of such damages.
//
//------------------------------------------------------------------------------
//
//  gramdesc.h : header file for the GrammarDescriptor class
//
//------------------------------------------------------------------------------

#ifndef GRAMMAR_DESC_H
#define GRAMMAR_DESC_H

#include "Stdafx.h"

enum  vocabularyTypes {fsg, wdl, external, dynamic};

//class GrammarDescriptor : public ListNode
class GrammarDescriptor
{
   private:

      BOOL             m_bNewDefinition;
      BOOL             m_bStateChange;
      BOOL             m_bSelected;
      vocabularyTypes  m_vocabularyType;
      CString          m_vTypeString;
      char             m_szVocabularyName[_MAX_PATH];
      char             m_szFSGFileName[_MAX_PATH];
      
   
   public:

      BOOL             newDefinition();
      BOOL             selected();
      BOOL             stateChange();
      vocabularyTypes  type();
      char const *     fsgFileName();
      char const *     vocabularyName();
      void             setSelect(BOOL selectFlag);
      void             acknowledgeNewDefinition();
      void             acknowledgeStateChange();
      void             setType(vocabularyTypes aType);
      const char *     typeString();
      GrammarDescriptor(char const *aGrammarName);
      ~GrammarDescriptor();
      
};

#endif
