//------------------------------------------------------------------------------
//
//    COPYRIGHT:
//    ----------
//    Copyright (C) International Business Machines Corp., 1996.
//
//      DISCLAIMER OF WARRANTIES:
//      -------------------------
//      The following [enclosed] code is sample code created by IBM
//      Corporation.  This sample code is not part of any standard IBM
//      product and is provided to you solely for the purpose of
//      assisting you in the development of your applications.  The
//      code is provided "AS IS", without warranty of any kind.  IBM
//      shall not be liable for any damages arising out of your use of
//      the sample code, even if they have been advised of the
//      possibility of such damages.
//
//------------------------------------------------------------------------------
//
//  gramsel.h : header file for the GrammarSelect dialog class
//
//------------------------------------------------------------------------------

#include "vtproxy.h"
#include "gramDesc.h"

class GrammarSelect : public CDialog
{

public:
 
	GrammarSelect(VTProxy   &aVTProxy,
                 CPtrArray &aGrammarList, 
		           CWnd* pParent = NULL);   // standard constructor

   ~GrammarSelect( );

   // Dialog Data
	//{{AFX_DATA(GrammarSelect)
	enum { IDD = IDD_GRAMMAR_SELECTION };
	CListCtrl	m_listVocabsNGrammars;
	CButton	m_radioSelect;
	//}}AFX_DATA


    // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(GrammarSelect)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:

	// Generated message map functions
	//{{AFX_MSG(GrammarSelect)
	afx_msg void OnButtonSelect();
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnDblclkListVocabsNGrammars(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

   

   // attributes
   CPtrArray  &m_listGrammarDescriptors;
   VTProxy    &m_pxySMAPI;
   BOOL       toggle;

	// methods
	void AddFileToGrammarList();
	void DefineNewGrammar(vocabularyTypes vType);
   void DisplayGrammar(GrammarDescriptor *theGrammar);
   void InitRadioButtons(); 
   void ShowGrammarList(); 

};
