// kioskDlg.h : header file
//

#include "smapidyn.h"

/////////////////////////////////////////////////////////////////////////////
// CKioskDlg dialog

class CKioskDlg : public CDialog
{
// Construction
public:
	CKioskDlg(CWnd* pParent = NULL);	// standard constructor
   void PopulateDialog(void);
   void StartRecoEngine(char *languagecode);
   void CopyPoolFile(char *languagecode);
   void StopRecoEngine(void);
   void SwitchRecoEngine(char *languagecode);
   void EnableGrammar(void);
   void DisableGrammar(void);
   BOOL ProcessEngineMessage(LPARAM lParam);
   void ProcessRecognizedPhrase(SM_MSG reply);
   void AnswerQuestion(CString szQuestion,CString szAnnotation);
   void SearchAnswer(CString szSearch);

// Dialog Data
	//{{AFX_DATA(CKioskDlg)
	enum { IDD = IDD_KIOSK_DIALOG };
	CString	m_answer;
	CString	m_question;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKioskDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
   char m_userid[32];
   char m_enrollid[32];
   char m_task[32];
   char m_engine_languagecode[8];
   char m_ui_languagecode[8];

	// Generated message map functions
	//{{AFX_MSG(CKioskDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#define ENGINE_CONNECTION_ID   WM_USER+1

#define PROJECT_PREFIX         "kiosk"
#define RESOURCE_DLL_SUFFIX    ".dll"
#define GRAMMAR_SUFFIX         ".fsg"
#define WORDPOOL_SUFFIX        ".ppl"
#define DATAFILE_SUFFIX        ".dat"

#define GRAMMAR_NAME           "town_grammar"
