#ifndef SMAPIDYN_H
#define SMAPIDYN_H

#include <smapi.h>

#ifdef __cplusplus
extern "C" {
#endif

/* types for the Sm* functions */

typedef int (*FT_SmAddCallback         )( char            *reply_name, SmHandler       (*handler) ( SM_MSG  reply, caddr_t client,  caddr_t call ), caddr_t          client_data );
typedef int (*FT_SmRemoveCallback      )( char            *reply_name, SmHandler       (*handler) ( SM_MSG  reply, caddr_t client,  caddr_t call ), caddr_t          client_data );
typedef int (*FT_SmAddPronunciation    )( char          *spelling,			    char          *pronunciation,			    long           uttno,                            short          repetitions,			    long           options,			    SM_MSG        *reply );
typedef int (*FT_SmAddToVocab          )( char          *vocab,			    short          nvocwords,                            SM_VOCWORD    *vocwords[],			    SM_MSG        *reply );
typedef int (*FT_SmApiVersionCheck     )( char          *caller_version,			    char         **sm_version );
typedef int (*FT_SmCancelPlayback      )( SM_MSG        *reply );
typedef int (*FT_SmClose               )( void );
typedef int (*FT_SmConnect             )( int            nargs,			    SmArg         *Args,			    SM_MSG        *reply );
typedef int (*FT_SmCorrectText         )( short          nwords,			    SM_WORD       *words[],			    SM_MSG        *reply );
typedef int (*FT_SmCorrectTextCancel   )( SM_MSG        *reply );
typedef int (*FT_SmDefineGrammar       )( char          *vocab,		            char          *grammar,			    long           options,		            SM_MSG        *reply );
typedef int (*FT_SmDefineVocab         )( char          *vocab,			    short          nvocwords,                            SM_VOCWORD    *vocwords[],			    SM_MSG        *reply );
typedef int (*FT_SmDisableVocab        )( char          *vocab,			    SM_MSG        *reply );
typedef int (*FT_SmDiscardData         )( SM_MSG        *reply );
typedef int (*FT_SmDisconnect          )( int            nargs,			    SmArg         *Args,			    SM_MSG        *reply );
typedef int (*FT_SmDispatch            )( unsigned long  ap_val );
typedef int (*FT_SmDetachSessions      )( SM_MSG        *reply );
typedef int (*FT_SmEnableVocab         )( char          *vocab,			    SM_MSG        *reply );
typedef int (*FT_SmEventNotify         )( long           event_id,			    long           options,			    SM_MSG        *reply );
typedef int (*FT_SmHaltRecognizer      )( SM_MSG        *reply );
typedef int (*FT_SmMicOff              )( SM_MSG        *reply );
typedef int (*FT_SmMicOn               )( SM_MSG        *reply );
typedef int (*FT_SmNewContext          )( short          nwords,			    SM_WORD       *words[],			    SM_MSG        *reply );
typedef int (*FT_SmOpen                )( int            nargs,			    SmArg         *Args );
typedef int (*FT_SmPlayMessage         )( char          *message_name,			    char          *language,			    SM_MSG        *reply );
typedef int (*FT_SmPlayUtterance       )( long           uttno,			    long           begtime,			    long           endtime,                            SM_MSG        *reply );
typedef int (*FT_SmPlayWords           )( short          ntags,			    long           tags[],			    long           options,                            SM_MSG        *reply );
typedef int (*FT_SmQuery               )( short          item,			    SM_MSG        *reply );
typedef int (*FT_SmQueryAddedWords     )( char          *vocab,			    SM_MSG        *reply );
typedef int (*FT_SmQueryAlternates     )( short          ntags,			    long           tags[],			    SM_MSG        *reply);
typedef int (*FT_SmQueryDefault        )( long           item,			    SM_MSG        *reply );
typedef int (*FT_SmQueryEnabledVocabs  )( SM_MSG        *reply );
typedef int (*FT_SmQueryEnrollIds      )( char          *user_id,			    char          *enroll_id,			    char          *language,                            SM_MSG        *reply );
typedef int (*FT_SmQueryLanguages      )( SM_MSG        *reply );
typedef int (*FT_SmQueryPronunciation  )( char          *spelling,			    SM_MSG        *reply );
typedef int (*FT_SmQueryPronunciations )( SM_MSG        *reply );
typedef int (*FT_SmQuerySessions       )( SM_MSG        *reply );
typedef int (*FT_SmQuerySpeechData     )( SM_MSG        *reply );
typedef int (*FT_SmQueryTasks          )( char          *language,			    SM_MSG        *reply );
typedef int (*FT_SmQueryUserInfo       )( char          *user_id,			    char          *enroll_id,			    char          *itemname,                            SM_MSG        *reply );
typedef int (*FT_SmQueryUsers          )( SM_MSG        *reply );
typedef int (*FT_SmQueryVocabs         )( SM_MSG        *reply );
typedef int (*FT_SmQueryWord           )( SM_WORD       *word,			    SM_MSG        *reply );
typedef int (*FT_SmReceiveMsg          )( unsigned       long ap_val,			    SM_MSG        *reply );
typedef int (*FT_SmRecognizeNextWord   )( SM_MSG        *reply );
typedef int (*FT_SmReleaseFocus        )( SM_MSG        *reply );
typedef int (*FT_SmRemoveFromVocab     )( char          *vocab,			    short          nvocwords,                            SM_VOCWORD    *vocwords[],			    SM_MSG        *reply );
typedef int (*FT_SmRemovePronunciation )( char          *spelling,			    char          *pronunciation,			    SM_MSG        *reply );
typedef int (*FT_SmRequestFocus        )( SM_MSG        *reply );
typedef int (*FT_SmRequestMicOff       )( SM_MSG        *reply );
typedef int (*FT_SmRequestMicOn        )( SM_MSG        *reply );
typedef int (*FT_SmRestoreSpeechData   )( char          *archive,			    long           version,			    SM_MSG        *reply );
typedef int (*FT_SmSaveSpeechData      )( char          *archive,			    long           version,			    long           flags,			    SM_MSG        *reply );
typedef int (*FT_SmSet                 )( short          item,			    long           value,			    SM_MSG        *reply );
typedef int (*FT_SmSetDefault          )( long           item,			    char          *item_value,			    SM_MSG        *reply );
typedef int (*FT_SmSetUserInfo         )( char          *user_id,			    char          *enroll_id,                            char          *itemname,			    char          *itemvalue,			    SM_MSG        *reply );
typedef int (*FT_SmUndefineVocab       )( char          *vocab,			    SM_MSG        *reply );
typedef int (*FT_SmWordCorrection      )( short          ntags,long tags[],short          nspells, char          *spellings[],   char          *pronunciations[], short          new_pronunciation, SM_MSG        *reply );
typedef int (*FT_SmGetAlphabets        )( SM_MSG sm_reply, unsigned long *nalphabets,                                                      char ***alphabets  );
typedef int (*FT_SmGetApplication      )( SM_MSG reply, char **application);
typedef int (*FT_SmGetApplications     )( SM_MSG sm_reply, unsigned long *nsessions,                                                   char ***reco_sessions  );
typedef int (*FT_SmGetAlternates       )( SM_MSG reply, unsigned long  *nwords,                                                              SM_WORD **words  );
typedef int (*FT_SmGetAudioLevel       )( SM_MSG sm_reply, short *volume );
typedef int (*FT_SmGetDescriptions     )( SM_MSG reply, unsigned long *ndescriptions,                                                   char ***descriptions  );
typedef int (*FT_SmGetEngineState      )( SM_MSG sm_reply, unsigned long *engine_state );
typedef int (*FT_SmGetEnrollId         )( SM_MSG reply, char **enroll_ids              );
typedef int (*FT_SmGetEnrollIds        )( SM_MSG reply, unsigned long *nenroll_ids,                                                       char ***enroll_ids  );
typedef int (*FT_SmGetEventId          )( SM_MSG reply, unsigned long  *event_id       );
typedef int (*FT_SmGetEventOptions     )( SM_MSG reply, unsigned long  *options        );
typedef int (*FT_SmGetFirmWords        )( SM_MSG reply, unsigned long  *nwords,                                                              SM_WORD **words  );
typedef int (*FT_SmGetFocusState       )( SM_MSG sm_reply, unsigned long *focus_state  );
typedef int (*FT_SmGetFocusChangeReason)( SM_MSG sm_reply, unsigned long *focus_change );
typedef int (*FT_SmGetGrammarPath      )( SM_MSG reply, char **grammar_path            );
typedef int (*FT_SmGetVocabPath        )( SM_MSG reply, char **vocab_path              );
typedef int (*FT_SmGetInfirmWords      )( SM_MSG reply, unsigned long  *nwords,                                                              SM_WORD **words  );
typedef int (*FT_SmGetItemValue        )( SM_MSG reply, unsigned long  *item,                                                   unsigned long *value  );
typedef int (*FT_SmGetLanguages        )( SM_MSG reply, unsigned long   *nlanguages,                                                       char ***languages  );
typedef int (*FT_SmGetMicState         )( SM_MSG sm_reply, unsigned long *mic_state    );
typedef int (*FT_SmGetMsgName          )( SM_MSG reply, char **message_name            );
typedef int (*FT_SmGetMsgType          )( SM_MSG sm_reply, int *msg_type               );
typedef int (*FT_SmGetNameValue        )( SM_MSG reply, char **name, char **value      );
typedef int (*FT_SmGetNumberWordMsgs   )( SM_MSG reply, unsigned long  *nwords         );
typedef int (*FT_SmGetPercentages      )( SM_MSG reply, unsigned long  *npercentages,                                                    short **percentages  );
typedef int (*FT_SmGetPhraseState      )( SM_MSG reply, unsigned long *phrase_state    );
typedef int (*FT_SmGetPronunciations   )( SM_MSG reply, unsigned long *npronun,                                                              char ***pronuns  );
typedef int (*FT_SmGetRc               )( SM_MSG reply, int *rc                        );
typedef int (*FT_SmGetRcName           )( SM_MSG sm_reply, char **rc_name              );
typedef int (*FT_SmGetRcDescription    )( SM_MSG sm_reply, char **rc_description       );
typedef int (*FT_SmReturnRc            )( SM_MSG sm_reply                              );
typedef char *(*FT_SmReturnRcName        )( int rc                                       );
typedef char *(*FT_SmReturnRcDescription )( int rc                                     );
typedef int (*FT_SmGetScripts          )( SM_MSG reply, unsigned long   *nscripts,                                                          char ***scripts  );
typedef int (*FT_SmGetService          )( SM_MSG reply, char **service                 );
typedef int (*FT_SmGetSessionId        )( SM_MSG reply, char **session_id              );
typedef int (*FT_SmGetSeverity         )( SM_MSG reply, unsigned long *severity        );
typedef int (*FT_SmGetSpeechDataArchive)( SM_MSG reply, char         **archive );
typedef int (*FT_SmGetSpeechDataOptions)( SM_MSG reply, long          *options );
typedef int (*FT_SmGetSpeechDataSize   )( SM_MSG reply, unsigned long *size    );
typedef int (*FT_SmGetSpeechDataVersion)( SM_MSG reply, long          *version );
typedef int (*FT_SmGetSpelling         )( SM_MSG reply, char **spelling                );
typedef int (*FT_SmGetSpellings        )( SM_MSG reply, unsigned long *nspellings,                                                      char ***spellings  );
typedef int (*FT_SmGetStates           )( SM_MSG reply, unsigned long  *nstates,                                                         short **states  );
typedef int (*FT_SmGetStatus           )( SM_MSG reply, int *status                    );
typedef int (*FT_SmGetTags             )( SM_MSG reply, unsigned long *ntags,                                                            long **tags  );
typedef int (*FT_SmGetTask             )( SM_MSG reply, char **tasks                   );
typedef int (*FT_SmGetTasks            )( SM_MSG reply, unsigned long *ntasks,                                                          char ***tasks  );
typedef int (*FT_SmGetTimes            )( SM_MSG reply, unsigned long *ntimes,                                                  unsigned long **times  );
typedef int (*FT_SmGetUserId           )( SM_MSG reply, char **user_ids                );
typedef int (*FT_SmGetUserIds          )( SM_MSG reply, unsigned long *nuser_ids,                                                       char ***user_ids  );
typedef int (*FT_SmGetUsers            )( SM_MSG reply, unsigned long *nusers,                                                          char ***users  );
typedef int (*FT_SmGetUtteranceNumber  )( SM_MSG reply, unsigned long  *nutterance     );
typedef int (*FT_SmGetVocabList        )( SM_MSG reply, unsigned long   *nvocabs,                                                         char ***vocabs  );
typedef int (*FT_SmGetVocabName        )( SM_MSG reply, char **vocabname               );
typedef int (*FT_SmGetVocWords         )( SM_MSG reply, unsigned long  *nwords,                                                     SM_VOCWORD **words  );
typedef int (*FT_SmGetWords            )( SM_MSG reply, unsigned long  *nwords,                                                        SM_WORD **words  );
typedef int (*FT_SmGetAnnotations      )( SM_MSG reply, unsigned long *nwords,                                             SM_ANNOTATION **annotations );
typedef int (*FT_SmGetWordTimes        )( SM_MSG reply, unsigned long *ntimes,      			   unsigned long **stimes, unsigned long **etimes  );

/* externally usable functions */

int SmApiLoadLibrary(void);
int SmApiFreeLibrary(void);

#define pSmSetArg(a,n,d) SmSetArg(a,n,d)   /* for consistency */
extern FT_SmAddCallback pSmAddCallback; 
extern FT_SmRemoveCallback pSmRemoveCallback; 
extern FT_SmAddPronunciation pSmAddPronunciation; 
extern FT_SmAddToVocab pSmAddToVocab; 
extern FT_SmApiVersionCheck pSmApiVersionCheck; 
extern FT_SmCancelPlayback pSmCancelPlayback; 
extern FT_SmClose pSmClose; 
extern FT_SmConnect pSmConnect; 
extern FT_SmCorrectText pSmCorrectText; 
extern FT_SmCorrectTextCancel pSmCorrectTextCancel; 
extern FT_SmDefineGrammar pSmDefineGrammar; 
extern FT_SmDefineVocab pSmDefineVocab; 
extern FT_SmDisableVocab pSmDisableVocab; 
extern FT_SmDiscardData pSmDiscardData; 
extern FT_SmDisconnect pSmDisconnect; 
extern FT_SmDispatch pSmDispatch; 
extern FT_SmDetachSessions pSmDetachSessions; 
extern FT_SmEnableVocab pSmEnableVocab; 
extern FT_SmEventNotify pSmEventNotify; 
extern FT_SmHaltRecognizer pSmHaltRecognizer; 
extern FT_SmMicOff pSmMicOff; 
extern FT_SmMicOn pSmMicOn; 
extern FT_SmNewContext pSmNewContext; 
extern FT_SmOpen pSmOpen; 
extern FT_SmPlayMessage pSmPlayMessage; 
extern FT_SmPlayUtterance pSmPlayUtterance; 
extern FT_SmPlayWords pSmPlayWords; 
extern FT_SmQuery pSmQuery; 
extern FT_SmQueryAddedWords pSmQueryAddedWords; 
extern FT_SmQueryAlternates pSmQueryAlternates; 
extern FT_SmQueryDefault pSmQueryDefault; 
extern FT_SmQueryEnabledVocabs pSmQueryEnabledVocabs; 
extern FT_SmQueryEnrollIds pSmQueryEnrollIds; 
extern FT_SmQueryLanguages pSmQueryLanguages; 
extern FT_SmQueryPronunciation pSmQueryPronunciation; 
extern FT_SmQueryPronunciations pSmQueryPronunciations; 
extern FT_SmQuerySessions pSmQuerySessions; 
extern FT_SmQuerySpeechData pSmQuerySpeechData; 
extern FT_SmQueryTasks pSmQueryTasks; 
extern FT_SmQueryUserInfo pSmQueryUserInfo; 
extern FT_SmQueryUsers pSmQueryUsers; 
extern FT_SmQueryVocabs pSmQueryVocabs; 
extern FT_SmQueryWord pSmQueryWord; 
extern FT_SmReceiveMsg pSmReceiveMsg; 
extern FT_SmRecognizeNextWord pSmRecognizeNextWord; 
extern FT_SmReleaseFocus pSmReleaseFocus; 
extern FT_SmRemoveFromVocab pSmRemoveFromVocab; 
extern FT_SmRemovePronunciation pSmRemovePronunciation; 
extern FT_SmRequestFocus pSmRequestFocus; 
extern FT_SmRequestMicOff pSmRequestMicOff; 
extern FT_SmRequestMicOn pSmRequestMicOn; 
extern FT_SmRestoreSpeechData pSmRestoreSpeechData; 
extern FT_SmSaveSpeechData pSmSaveSpeechData; 
extern FT_SmSet pSmSet; 
extern FT_SmSetDefault pSmSetDefault; 
extern FT_SmSetUserInfo pSmSetUserInfo; 
extern FT_SmUndefineVocab pSmUndefineVocab; 
extern FT_SmWordCorrection pSmWordCorrection; 
extern FT_SmGetAlphabets pSmGetAlphabets; 
extern FT_SmGetApplication pSmGetApplication; 
extern FT_SmGetApplications pSmGetApplications; 
extern FT_SmGetAlternates pSmGetAlternates; 
extern FT_SmGetAudioLevel pSmGetAudioLevel; 
extern FT_SmGetDescriptions pSmGetDescriptions; 
extern FT_SmGetEngineState pSmGetEngineState; 
extern FT_SmGetEnrollId pSmGetEnrollId; 
extern FT_SmGetEnrollIds pSmGetEnrollIds; 
extern FT_SmGetEventId pSmGetEventId; 
extern FT_SmGetEventOptions pSmGetEventOptions; 
extern FT_SmGetFirmWords pSmGetFirmWords; 
extern FT_SmGetFocusState pSmGetFocusState; 
extern FT_SmGetFocusChangeReason pSmGetFocusChangeReason; 
extern FT_SmGetGrammarPath pSmGetGrammarPath; 
extern FT_SmGetVocabPath pSmGetVocabPath; 
extern FT_SmGetInfirmWords pSmGetInfirmWords; 
extern FT_SmGetItemValue pSmGetItemValue; 
extern FT_SmGetLanguages pSmGetLanguages; 
extern FT_SmGetMicState pSmGetMicState; 
extern FT_SmGetMsgName pSmGetMsgName; 
extern FT_SmGetMsgType pSmGetMsgType; 
extern FT_SmGetNameValue pSmGetNameValue; 
extern FT_SmGetNumberWordMsgs pSmGetNumberWordMsgs; 
extern FT_SmGetPercentages pSmGetPercentages; 
extern FT_SmGetPhraseState pSmGetPhraseState; 
extern FT_SmGetPronunciations pSmGetPronunciations; 
extern FT_SmGetRc pSmGetRc; 
extern FT_SmGetRcName pSmGetRcName; 
extern FT_SmGetRcDescription pSmGetRcDescription; 
extern FT_SmReturnRc pSmReturnRc; 
extern FT_SmReturnRcName pSmReturnRcName; 
extern FT_SmReturnRcDescription pSmReturnRcDescription; 
extern FT_SmGetScripts pSmGetScripts; 
extern FT_SmGetService pSmGetService; 
extern FT_SmGetSessionId pSmGetSessionId; 
extern FT_SmGetSeverity pSmGetSeverity; 
extern FT_SmGetSpeechDataArchive pSmGetSpeechDataArchive; 
extern FT_SmGetSpeechDataOptions pSmGetSpeechDataOptions; 
extern FT_SmGetSpeechDataSize pSmGetSpeechDataSize; 
extern FT_SmGetSpeechDataVersion pSmGetSpeechDataVersion; 
extern FT_SmGetSpelling pSmGetSpelling; 
extern FT_SmGetSpellings pSmGetSpellings; 
extern FT_SmGetStates pSmGetStates; 
extern FT_SmGetStatus pSmGetStatus; 
extern FT_SmGetTags pSmGetTags; 
extern FT_SmGetTask pSmGetTask; 
extern FT_SmGetTasks pSmGetTasks; 
extern FT_SmGetTimes pSmGetTimes; 
extern FT_SmGetUserId pSmGetUserId; 
extern FT_SmGetUserIds pSmGetUserIds; 
extern FT_SmGetUsers pSmGetUsers; 
extern FT_SmGetUtteranceNumber pSmGetUtteranceNumber; 
extern FT_SmGetVocabList pSmGetVocabList; 
extern FT_SmGetVocabName pSmGetVocabName; 
extern FT_SmGetVocWords pSmGetVocWords; 
extern FT_SmGetWords pSmGetWords; 
extern FT_SmGetAnnotations pSmGetAnnotations; 
extern FT_SmGetWordTimes pSmGetWordTimes; 

#ifdef __cplusplus
}
#endif

#endif

