// SwitchModeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SwitchMode.h"
#include "SwitchModeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSwitchModeDlg dialog

CSwitchModeDlg::CSwitchModeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSwitchModeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSwitchModeDlg)
	m_strEdit1 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSwitchModeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSwitchModeDlg)
	DDX_Control(pDX, IDC_EDIT1, m_ctlEdit);
	DDX_Control(pDX, IDC_VVDICTATIONMGR1, m_DictMgr);
	DDX_Text(pDX, IDC_EDIT1, m_strEdit1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSwitchModeDlg, CDialog)
	//{{AFX_MSG_MAP(CSwitchModeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_WavInput, OnWavInput)
	ON_BN_CLICKED(IDC_Clear, OnClear)
	ON_BN_CLICKED(IDC_SelectMicrophone, OnSelectMicrophone)
	ON_BN_CLICKED(IDC_SelectWAVFile, OnSelectWAVFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSwitchModeDlg message handlers

BOOL CSwitchModeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
   m_Engine=m_DictMgr.GetEngine();
   m_Engine.SetAutoUI(TRUE);       
	   
   SetDlgItemText(IDC_FileName,_T("D:\\temp\\paudicus.wav"));
   
   OnSelectMicrophone();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSwitchModeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSwitchModeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CSwitchModeDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CSwitchModeDlg)
	ON_EVENT(CSwitchModeDlg, IDC_VVDICTATIONMGR1, 2 /* PutText */, OnPutTextVvdictationmgr1, VTS_BSTR VTS_I4 VTS_I4 VTS_I4 VTS_BOOL)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSwitchModeDlg::OnPutTextVvdictationmgr1(LPCTSTR Text, long StartIndex, long TextLength, long CursorIndex, BOOL PhraseComplete) 
{
   int start,end;
   m_ctlEdit.GetSel(start,end);
   m_ctlEdit.ReplaceSel(Text);
   m_ctlEdit.SetSel(start+(CursorIndex-StartIndex), start+(CursorIndex-StartIndex));
  
}

void CSwitchModeDlg::OnWavInput() 
{

   TCHAR szFileName[128];
   GetDlgItemText(IDC_FileName,szFileName,sizeof(szFileName));

   m_Engine.SetAudioSource(szFileName);      	
	m_DictMgr.SetDictationOn(TRUE);
   m_Engine.SetAudioState(1);  //vvasStarted	   
   m_Engine.SetAudioSource(_T(""));     
 		
   m_ctlEdit.SetFocus();	             
}



void CSwitchModeDlg::OnClear() 
{
  SetDlgItemText(IDC_EDIT1,_T(""));
}

void CSwitchModeDlg::OnSelectMicrophone() 
{

   SetWindowText(_T("Microphone"));

   ((CButton*)GetDlgItem(IDC_SelectMicrophone))->SetCheck(1);

   ((CButton*)GetDlgItem(IDC_WavInput))->EnableWindow(FALSE);

 
   if (m_Engine.GetIsConnected())
       m_Engine.Disconnect();
    
   
   m_Engine.SetUseSharedEngine(TRUE);
   m_Engine.SetAutoStartAudio(TRUE);
   m_Engine.SetAudioSourceType(0);  //vvFixedAudio
   m_Engine.SetAudioSource(_T("")); 
   m_DictMgr.SetRefEngine(LPDISPATCH(m_Engine));	
   m_Engine.Connect();

	m_DictMgr.SetDictationOn(TRUE);
   m_Engine.SetAudioState(1);  //vvasStarted	

   m_ctlEdit.SetFocus();
   
}

void CSwitchModeDlg::OnSelectWAVFile() 
{
   
   SetWindowText(_T("WAV File"));
  
   ((CButton*)GetDlgItem(IDC_WavInput))->EnableWindow(TRUE);

   
   if (m_Engine.GetIsConnected())
       m_Engine.Disconnect();
       
   m_Engine.SetUseSharedEngine(FALSE);
   m_Engine.SetAutoStartAudio(FALSE);
   m_Engine.SetAudioSourceType(3);  //vvWAVFile         
   m_Engine.SetAudioSource(_T(""));      		
	m_DictMgr.SetRefEngine(LPDISPATCH(m_Engine));	
   m_Engine.Connect();
   
}
